#! /usr/bin/python

from PyQt4 import QtGui

##

class Mixin(object):

    def __init__(self, what):
        self.what = what

    def insert(self):
        print 'inserting', self.what

    def remove(self):
        print 'removing', self.what

##

class InsertCmd(QtGui.QUndoCommand, Mixin):

    def __init__(self, what):
        QtGui.QUndoCommand.__init__(self, 'insert ' + what)
        Mixin.__init__(self, what)

    undo = Mixin.remove
    redo = Mixin.insert

class RemoveCmd(QtGui.QUndoCommand, Mixin):

    def __init__(self, what):
        QtGui.QUndoCommand.__init__(self, 'remove ' + what)
        Mixin.__init__(self, what)

    undo = Mixin.insert
    redo = Mixin.remove

##

undo_stack = QtGui.QUndoStack()
insert_cmd = InsertCmd('foo')
remove_cmd = RemoveCmd('bar')

undo_stack.push(insert_cmd)
undo_stack.push(remove_cmd)

